unit EnhancedListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TEnhancedListBox = class(TListBox)
  private
    { Private declarations }
    FItemIndex: Integer;
    FText: String;
  protected
    { Protected declarations }
    procedure Click; override;
  public
    { Public declarations }
  published
    { Published declarations }
    property Text: String
        read FText write FText;
    property Align;
    property Anchors;
    property BiDiMode;
    property BorderStyle;
    property Color;
    property Columns;
    property Constraints;
    property Cursor;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ExtendedSelect;
    property Font;
    property Height;
    property HelpContext;
    property Hint;
    property ImeMode;
    property ImeName;
    property IntegralHeight;
    property ItemHeight;
    property Items;
    property Left;
    property MultiSelect;
    property Name;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property Style;
    property TabOrder;
    property TabStop;
    property TabWidth;
    property Tag;
    property Top;
    property Visible;
    property Width;

    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Alexis Ros', [TEnhancedListBox]);
end;

procedure TEnhancedListBox.Click;
begin
        if (self.ItemIndex <> -1) and (MultiSelect = False) then begin
          FItemIndex := self.ItemIndex;
          FText := self.Items.Strings[FItemIndex];
        end
        else
           FText := '';
        inherited;   
end;

end.
