unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, DocView;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    DocView1: TDocView;
    SaveDialog1: TSaveDialog;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
  private
    { Private declarations }
    procedure CreateMDIChild(const Name: string);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin, About;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
var
        Child: TMDIChild;
begin
  With OpenDialog do begin
       Filter := DocView1.AppDescription + ' Files (*.' + DocView1.AppExtension + ')|' +
          '*.'+DocView1.AppExtension;
  end;

  if OpenDialog.Execute then begin
    CreateMDIChild(OpenDialog.FileName);
    Child := ActiveMDIChild as TMDIChild;
    Child.Memo1.Lines.LoadFromFile(OpenDialog.Filename);
  end;
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
        isRegistered: Boolean;
        Child: TMDIChild;
begin
        //Check if the file extension is already registered
        isRegistered := DocView1.CheckExtension(self);
        if not isRegistered then
                //If it's not registered then registered
                DocView1.ShellReg(self, Application.ExeName, 0, 1);
        (* If an associated file was selected from the Windows Explorer
           this will auto-load the file *)
        if (ParamCount() > 0) then begin
            CreateMDIChild(ParamStr(1));
            Child := ActiveMDIChild as TMDIChild;
            DocView1.AutoLoadTextFile(Child.Memo1);
        end;


end;
procedure TMainForm.FileSave1Execute(Sender: TObject);
var
        Child: TMDIChild;
begin
        With SaveDialog1 do begin
             Filter := DocView1.AppDescription + ' Files (*.' + DocView1.AppExtension + ')|' +
                '*.'+DocView1.AppExtension;
             DefaultExt := DocView1.AppExtension;                   
        end;
        if SaveDialog1.Execute then begin
                Child := ActiveMDIChild as TMDIChild;
                DocView1.SaveAsText(Child.Memo1.Lines, SaveDialog1.FileName);
                Child.Caption := SaveDialog1.FileName;
        end;

end;

end.
