unit Sdimain;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList, StdActns,
  ActnList, ToolWin, DocView;

type
  TSDIAppForm = class(TForm)
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ToolBar1: TToolBar;
    ToolButton9: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ActionList1: TActionList;
    FileNew1: TAction;
    FileOpen1: TAction;
    FileSave1: TAction;
    FileSaveAs1: TAction;
    FileExit1: TAction;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    HelpAbout1: TAction;
    StatusBar: TStatusBar;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    Help1: TMenuItem;
    HelpAboutItem: TMenuItem;
    RichEdit1: TRichEdit;
    DocView1: TDocView;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SDIAppForm: TSDIAppForm;

implementation

uses About;

{$R *.DFM}

procedure TSDIAppForm.FileNew1Execute(Sender: TObject);
begin
  { Do nothing }
end;

procedure TSDIAppForm.FileOpen1Execute(Sender: TObject);
begin
  With OpenDialog do begin
       Filter := DocView1.AppDescription + ' Files (*.' + DocView1.AppExtension + ')|' +
          '*.'+DocView1.AppExtension;
  end;

  if OpenDialog.Execute then begin
     DocView1.Unserialize(RichEdit1, OpenDialog.Filename);
  end;
end;

procedure TSDIAppForm.FileSave1Execute(Sender: TObject);
begin
  With SaveDialog do begin
       Filter := DocView1.AppDescription + ' Files (*.' + DocView1.AppExtension + ')|' +
          '*.'+DocView1.AppExtension;
       DefaultExt := DocView1.AppExtension;
  end;

  if(SaveDialog.Execute) then begin
    DocView1.Serialize(RichEdit1, SaveDialog.Filename);
  end;

end;

procedure TSDIAppForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TSDIAppForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TSDIAppForm.FormShow(Sender: TObject);
var
        isRegistered: Boolean;
begin
        //Check if the file extension is already registered
        isRegistered := DocView1.CheckExtension(self);
        if not isRegistered then
                //If it's not registered then registered
                DocView1.ShellReg(self, Application.ExeName, 0, 1);
        (* If an associated file was selected from the Windows Explorer
           this will auto-load the file *)
        if ParamCount() > 0 then
            (* You can use the AutoLoadFile or
               the Unserialize method *);
            DocView1.AutoLoadFile(RichEdit1);
            //DocView1.Unserialize(RichEdit1, ParamStr(1));
end;

end.
