unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WinSystem, StdCtrls, Buttons, FileCtrl, Menus;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    lblOS: TLabel;
    Label2: TLabel;
    lblComputer: TLabel;
    Label3: TLabel;
    lblUser: TLabel;
    Label4: TLabel;
    lblMaxColors: TLabel;
    WinSystem1: TWinSystem;
    optReboot: TRadioButton;
    optShutdown: TRadioButton;
    optLogoff: TRadioButton;
    Button1: TButton;
    Label5: TLabel;
    txtWebSite: TEdit;
    BitBtn1: TBitBtn;
    Label6: TLabel;
    lblFileSize: TLabel;
    OpenDialog1: TOpenDialog;
    SpeedButton1: TSpeedButton;
    Button2: TButton;
    Button3: TButton;
    chkRunOnce: TCheckBox;
    Button4: TButton;
    Label7: TLabel;
    lblDriveType: TLabel;
    txtDriveType: TEdit;
    chkSaver: TCheckBox;
    Label8: TLabel;
    lblSmallFonts: TLabel;
    Button5: TButton;
    Memo1: TMemo;
    Button6: TButton;
    Button7: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure chkSaverClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation


{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
    //Center screen on form with code
    self.Top := (Screen.Height - self.Height) div 2;
    self.Left := (Screen.Width - self.Width) div 2;
    With WinSystem1 do
    begin
       GetOSInfo();
       GetComputerInfo();
       GetColorsCount();
       GetFontSize();
       GetExeVersion(Application.ExeName);
    end;
    lblOS.Caption := WinSystem1.WindowsType + ' ' +
        WinSystem1.MajorVersion + '.' + WinSystem1.MinorVersion + '.' +
        WinSystem1.BuildNumber + ' ' + WinSystem1.OtherInfo;
    lblComputer.Caption := WinSystem1.ComputerName;
    lblUser.Caption := WinSystem1.UserId;
    lblMaxColors.Caption := WinSystem1.MaxColors;
    lblFileSize.Caption := '0 bytes';
    if WinSystem1.UsingSmallFonts then
        lblSmallFonts.Caption := 'YES'
    else
        lblSmallFonts.Caption := 'NO';

    Memo1.Lines.Add(WinSystem1.FileVersion);
    Memo1.Lines.Add(WinSystem1.CompanyName);
    Memo1.Lines.Add(WinSystem1.FileDescription);
    Memo1.Lines.Add(WinSystem1.InternalName);
    Memo1.Lines.Add(WinSystem1.LegalCopyright);
    Memo1.Lines.Add(WinSystem1.LegalTradeMarks);
    Memo1.Lines.Add(WinSystem1.ProductVersion);
    Memo1.Lines.Add(WinSystem1.OriginalFilename);
    Memo1.Lines.Add(WinSystem1.ProductName);
    Memo1.Lines.Add(WinSystem1.Comments);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    if optReboot.Checked then
        WinSystem1.WinExit(EWX_REBOOT + EWX_FORCE)
    else if optShutdown.Checked then
        WinSystem1.WinExit(EWX_SHUTDOWN + EWX_FORCE + EWX_POWEROFF)
    else if optLogoff.Checked then
        WinSystem1.WinExit(EWX_LOGOFF + EWX_FORCE);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    WinSystem1.GoWeb(self, txtWebSite.Text);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
    if OpenDialog1.Execute() then
    begin
        lblFileSize.Caption := IntToStr(WinSystem1.GetFileSize(OpenDialog1.FileName)) + ' bytes';
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    //If you don't want your program to load at startup anymore use the RevokeRunOnStartup procedure
    WinSystem1.RevokeRunOnStartup('WinSystem Demo');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    (* When Windows loads the program will start automatically. If you select Run Once
       the application will autoload when Windows is next restarted just one time *)
       
    WinSystem1.RunOnStartup('WinSystem Demo',Application.ExeName,chkRunOnce.Checked);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    lblDriveType.Caption := WinSystem1.GetDiskDriveType(txtDriveType.Text);
end;
procedure TForm1.chkSaverClick(Sender: TObject);
begin
    //Disable your screen saver so it can't affect the performance of your application
    if chkSaver.Checked then
        WinSystem1.DisableScreenSaver()
    else
        WinSystem1.EnableScreenSaver();
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
WinSystem1.RecycleFiles(self, 'C:\MoveLocation\*.dll');
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    WinSystem1.CopyFlyingFiles(self, 'C:\Winnt\System32\*.dll', 'C:\temp');

end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    if not DirectoryExists('C:\MoveLocation') then
        MKDir('C:\MoveLocation');
    WinSystem1.MoveFlyingFiles(self, 'C:\temp\*.dll', 'C:\MoveLocation');
end;


procedure TForm1.About1Click(Sender: TObject);
begin
        MessageBox(Handle, 'WinSystem Control Example', 'Alexis Ros', MB_ICONINFORMATION);
end;

end.
