unit Hex;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  THex = class(TComponent)
  private
    { Private declarations }
    FText: String;
    FHex: String;
    FNumber: Integer;
    function StrToHex(value: String): String;
    function HexToStr(value: String): String;
    function HexToInt(value: String): Integer;
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure ToHex();
    procedure ToStr();
    procedure ToInt();
  published
    { Published declarations }
    property Text: String read FText write FText;
    property Hex: String read FHex write FHex;
    property Number: Integer read FNumber write FNumber;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Alexis Ros', [THex]);
end;

function THex.StrToHex(value: String): String;
var
    hexValue: String;
    ch: Char;
    i: Integer;
begin
  for i := 1 to Length(value) do
  begin
    try
      ch := value[i];
      hexValue := hexValue + IntToHex(Integer(ch),1) + ' ';
    except
      Beep;
    end;
  end;
  Result:= hexValue;
end;

function THex.HexToStr(value: String): String;
var
    i: Integer;
    intValue: Integer;
    ch: String;
    sub: String;
    strValue: String;
begin
   sub:='';
   for i:= 1 to Length(value) do begin
        ch := Copy(value,i,1);
        if Trim(ch) <> '' then
         begin
            sub := sub + ch;
         end
        else
         begin
            intValue := HexToInt(sub);
            strValue := strValue + Chr(intValue);
            sub := '';
         end;
   end;
   Result:= strValue;
end;

function THex.HexToInt(value: String): Integer;
begin
    Result:= StrToInt('0x' + value);
end;
procedure THex.ToInt();
begin
   FNumber := HexToInt(FHex);
end;

procedure THex.ToHex();
begin
    FHex := StrToHex(FText);
end;

procedure THex.ToStr();
begin
    FText := HexToStr(FHex);
end;
end.
