unit NumericEditBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TNumericEditBox = class(TEdit)
  private
    { Private declarations }
    FDecimalPart: Boolean;
    FOnInvalidCharacter: TNotifyEvent;
  protected
    { Protected declarations }
    procedure KeyPress(var Key: Char); override;
    procedure DoInvalidCharacter; virtual;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property AllowDecimals: Boolean
        read FDecimalPart write FDecimalPart default True;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Cursor;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property Height;
    property HelpContext;
    property HideSelection;
    property Hint;
    property ImeMode;
    property ImeName;
    property Left;
    property MaxLength;
    property Name;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Tag;
    property Text;
    property Top;
    property Visible;
    property Width;

    property OnInvalidCharacter: TNotifyEvent
        read FOnInvalidCharacter write FOnInvalidCharacter;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;


  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Alexis Ros', [TNumericEditBox]);
end;

constructor TNumericEditBox.Create(AOwner: TComponent);     { this goes after implementation }
begin
  inherited Create(AOwner);                           { ALWAYS do this first! }
  Text := '0';
  FDecimalPart := true;                                        { set the new desired value }
end;
procedure TNumericEditBox.KeyPress(var Key: Char);
begin
        if FDecimalPart then begin
                if not (Key in ['0'..'9', #8, '.']) then begin
                        Beep();
                        Key := #0;
                        DoInvalidCharacter;
                end;
        end else begin
                if not (Key in ['0'..'9', #8]) then begin
                        Beep();
                        Key := #0;
                        DoInvalidCharacter;
                end;

        end;
        inherited;
end;

procedure TNumericEditBox.DoInvalidCharacter;
begin
   if Assigned(FOnInvalidCharacter) then
        FOnInvalidCharacter(self);

end;
end.
