unit WebLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellApi, mmsystem;

type
  TErrorLoading =
        procedure(Sender: TObject; ErrorMessage: String) of object;
  TWebLabel = class(TCustomLabel)
  private
    { Private declarations }
    FColor : TColor;
    FClickColor: TColor;
    FOnErrorLoading: TErrorLoading;

  protected
    { Protected declarations }
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure DoErrorLoading; virtual;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);override;
  published
    { Published declarations }
    property ClickColor: TColor
        read FClickColor write FClickColor default clRed;
    property Align;
    property Alignment;
    property AutoSize;
    property BiDiMode;
    property Caption;
    property Color;
    property Constraints;
    property Cursor;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;

    property OnErrorLoading: TErrorLoading
        read FOnErrorLoading write FOnErrorLoading;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Alexis Ros', [TWebLabel]);
end;

constructor TWebLabel.Create(AOwner: TComponent);     { this goes after implementation }
begin
  inherited Create(AOwner);                           { ALWAYS do this first! }
  Caption := 'http://www.yourcompany.com';
  Transparent := true;
  Cursor := crHandPoint;
  FClickColor := clRed;
  self.Font.Color := clBlue;

end;

procedure TWebLabel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FColor := self.Font.Color;
  if Button = mbLeft then
          self.Font.Color := FClickColor;
end;

procedure TWebLabel.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
        returnedValue: Longint;
begin
  if Button = mbLeft then begin
        self.Font.Color := FColor;
        returnedValue := ShellExecute(0,'open', PChar(self.Caption), nil, nil, SW_SHOWNORMAL);
        if returnedValue <= 32 then
                DoErrorLoading;
  end;
end;

procedure TWebLabel.DoErrorLoading;
begin
    if Assigned(FOnErrorLoading) then
        FOnErrorLoading(self, 'Unable to load browser');
end;

end.

